/**
 *  Behaviour of a return in a closure.
 */

def isMemberA(item, list) {
    def size = list.size()
    for(index in 0..<size) {
        if(list[index] == item)
            return true
    }
    return false
}

def isMemberB(item, list) {
    list.each { element ->
        //println "searching: ${element}"
        if(element == item)
            return true
    }
    return false
}

def numbers = [11, 12, 13, 14]

println "isMemberA(15, numbers): ${isMemberA(15, numbers)}"	// OK: false
println "isMemberA(13, numbers): ${isMemberA(13, numbers)}"	// OK: true

println "isMemberB(15, numbers): ${isMemberB(15, numbers)}"	// OK: false
println "isMemberB(13, numbers): ${isMemberB(13, numbers)}"	// ERROR: false
