import fp.*

	// Book class and instance
class Book {

    def name	// properties
    def author
    def price
    def category
}

def bk = new Book(name : 'Groovy', author : 'KenB', price : 35, category : 'CompSci')

	// constants
def discountRate = 0.1
def taxRate = 0.17
def maxDiscount = 3

	//  book closures
def calcDiscount = Functor.rMultiply.curry(discountRate)

def calcActualDiscount = Functor.bComposition.curry(Functor.bMin, calcDiscount, Functor.id)

def calcDiscountedPrice = Functor.bComposition.curry(Functor.bSubtract, Functor.id, calcActualDiscount)

def calcTax = Functor.rMultiply.curry(1 + taxRate)

def calcNetPrice = Functor.composition.curry(calcTax, calcDiscountedPrice)

	//  now calculate net price
println "bk.price: ${bk.price}"

def netPrice = calcNetPrice(bk.price)
println "netPrice: ${netPrice}"

