/**
 *  A closure can refer to variables visible at the time it is
 *    defined. If the value of any such variables changes then
 *    this is reflected in the closure call.
 */

def greeting = 'Hello'
def clos = { param -> println "${greeting} ${param}" }
clos.call('world')

//  Now show that changes to this variable change the closure.
greeting = 'Welcome'
clos.call('world')

def demo(clo) {
    def greeting = 'Bonjour'	// does not affect closure
    clo.call('Ken')
}

demo(clos)
