/**
 *  A simple XML demonstration using a MarkupBuilder.
 *    The example creates some XML representing the
 *    details of a book. The resulting XML is streamed
 *    to a named file.
 */

import groovy.xml.MarkupBuilder
import java.io.*

	//  Create a builder
def mB = new MarkupBuilder(new File('book.xml').newPrintWriter())

	//  Compose the builder
mB.book() {
    author('Ken Barclay')		// producing <author>Ken Barclay</author>
    title('Groovy')
    publisher('Elsevier')
    isbn(number : '1234567890')		// producing <isbn number='1234567890'/>
}

