/**
 *  Using asType to convert a closure to act as an instance of an interface.
 */

interface CalculatorIF {

    def abstract add(first, second)
}

class Klass {

    def method(one, two, CalculatorIF m) {
        return m.add(one, two)
    }
}

def kl = new Klass()
def answer = kl.method(1, 2, {x, y -> return x + y}.asType(CalculatorIF))
println "Answer: ${answer}"
